import 'package:flutter/widgets.dart';
import 'package:nui_auth/domain/nui_user_activity.dart';
import 'package:nui_auth/nui_auth.dart';
import 'package:nui_core/nui_core.dart';
import 'package:nui_core/ui/component/nui_screen_widget.dart';

class NUIAuthScreen extends StatelessWidget {
  NUIAuthScreen({required this.module, required this.child, this.overlay});
  final String module;
  final Widget child;
  final NUIOverlayStyle? overlay;

  void _logUserActivity(BuildContext context) async{
    try{
      final result = await NUIAuth.get().logUserActivity(userActivity: NUIUserActivity(
        module: module,
        action: "Launch",
        time: DateTime.now()
      ));
      if(result.success){
        logNUI("NUIAuthScreen", "Logged user activity for module visit : $module at ${DateTime.now()}");
      }
    }catch(e,s){
      logNUI("NUIAuthScreen", "Failed to log user activity with error : $e, stacktrace : $s");
    }
  }

  @override
  Widget build(BuildContext context) {
    _logUserActivity(context);
    return NUIScreen(content: (context) => child, screenCode: module, overlayStyle: overlay);
  }
}
