import 'package:nui_auth/web/json/resp/nui_auth_standard_resp.dart';
import 'package:nui_core/model/interfaces.dart';
import 'package:nui_web/nui_web_models.dart';

class DataResultFactory {

  DataResult<T> defineDataResult<T>(NUIHttpResponse<NUIAuthStandardResp> resp, {dynamic successDataIfNull, dynamic failureData}){
    return (resp.success && (resp.body?.success ?? false))
        ? _defineSuccess<T>(resp, dataIfNull: successDataIfNull)
        : _defineFailure<T>(resp, data: failureData);
  }

  DataResult<T> _defineSuccess<T>(NUIHttpResponse<NUIAuthStandardResp> resp, {dynamic dataIfNull}){
    return DataResult<T>(
        success: resp.body?.success ?? false,
        message: resp.body?.message ?? "",
        code: resp.body?.message ?? "",
        data: resp.body?.data ?? dataIfNull
    );
  }

  DataResult<T> _defineFailure<T>(NUIHttpResponse<NUIAuthStandardResp> resp, {dynamic data}){
    return DataResult(
        success: resp.body?.success ?? false,
        message: resp.body?.error?.errorMessage ?? "",
        code: resp.body?.error?.errorCode ?? "",
        data: data
    );
  }
}