import 'package:nui_core/data/nui_ent.dart';

class NUIAuthDeviceInfo extends NUIEnt<NUIAuthDeviceInfo>{

  NUIAuthDeviceInfo({required this.deviceId, required this.deviceModel, required this.deviceOs, required this.osVersion, required this.ipAddress});
  NUIAuthDeviceInfo.empty();
  late String deviceId;
  late String deviceModel;
  late String deviceOs;
  late String osVersion;
  late String ipAddress;

  @override
  NUIEntMapper<NUIAuthDeviceInfo> mapper() => NUIAuthDeviceInfoEnt();

}

class NUIAuthDeviceInfoEnt extends NUIEntMapper<NUIAuthDeviceInfo>{
  @override
  String entityName() => "NUIAuthDeviceInfoEnt";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIAuthDeviceInfo>(name: "deviceId", type: NUIEntType.STRING, setter: (data, value) => data.deviceId = value, getter: (data) => data.deviceId),
      NUIEntField<NUIAuthDeviceInfo>(name: "deviceModel", type: NUIEntType.STRING, setter: (data, value) => data.deviceModel = value, getter: (data) => data.deviceModel),
      NUIEntField<NUIAuthDeviceInfo>(name: "deviceOs", type: NUIEntType.STRING, setter: (data, value) => data.deviceOs = value, getter: (data) => data.deviceOs),
      NUIEntField<NUIAuthDeviceInfo>(name: "osVersion", type: NUIEntType.STRING, setter: (data, value) => data.osVersion = value, getter: (data) => data.osVersion),
      NUIEntField<NUIAuthDeviceInfo>(name: "ipAddress", type: NUIEntType.STRING, setter: (data, value) => data.ipAddress = value, getter: (data) => data.ipAddress),
    ];
  }

  @override
  NUIAuthDeviceInfo newInstance() => NUIAuthDeviceInfo.empty();

}