import 'package:nui_auth/web/json/req/nui_auth_device_info.dart';
import 'package:nui_core/data/nui_ent.dart';

class NUIAuthLoginReq extends NUIEnt<NUIAuthLoginReq>{
  NUIAuthLoginReq.empty();
  NUIAuthLoginReq({required this.username, required this.password, required this.deviceInfo, this.provider});
  late String username;
  late String password;
  String? provider;
  late NUIAuthDeviceInfo deviceInfo;

  @override
  NUIEntMapper<NUIAuthLoginReq> mapper() => NUIAuthLoginReqEnt();
}
class NUIAuthLoginReqEnt extends NUIEntMapper<NUIAuthLoginReq>{
  @override
  String entityName() => "NUIAuthLoginReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLoginReq>(name: "username", type: NUIEntType.STRING, setter: (data, value) => data.username = value, getter: (data) => data.username),
    NUIEntField<NUIAuthLoginReq>(name: "password", type: NUIEntType.STRING, setter: (data, value) => data.password = value, getter: (data) => data.password),
    NUIEntField<NUIAuthLoginReq>(name: "provider", type: NUIEntType.STRING, setter: (data, value) => data.provider = value, getter: (data) => data.provider),
    NUIEntField<NUIAuthLoginReq>(name: "deviceInfo", type: NUIEntType.OBJECT, setter: (data, value) => data.deviceInfo = asObject(NUIAuthDeviceInfoEnt(), value) as NUIAuthDeviceInfo, getter: (data) => data.deviceInfo),
  ];

  @override
  NUIAuthLoginReq newInstance() => NUIAuthLoginReq.empty();
}


class NUIAuthLoginResp extends NUIEnt<NUIAuthLoginResp>{
  NUIAuthLoginResp.empty();
  late String accessToken;
  late String refreshToken;
  late String email;
  String? mobileNo;
  String? displayName;

  @override
  NUIEntMapper<NUIAuthLoginResp> mapper() => NUIAuthLoginRespEnt();
}
class NUIAuthLoginRespEnt extends NUIEntMapper<NUIAuthLoginResp>{
  @override
  String entityName() => "NUIAuthLoginResp";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLoginResp>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
    NUIEntField<NUIAuthLoginResp>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
    NUIEntField<NUIAuthLoginResp>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
    NUIEntField<NUIAuthLoginResp>(name: "mobileNo", type: NUIEntType.STRING, setter: (data, value) => data.mobileNo = value, getter: (data) => data.mobileNo),
    NUIEntField<NUIAuthLoginResp>(name: "displayName", type: NUIEntType.STRING, setter: (data, value) => data.displayName = value, getter: (data) => data.displayName),
  ];

  @override
  NUIAuthLoginResp newInstance() => NUIAuthLoginResp.empty();
}