import 'package:nui_auth/web/json/req/nui_auth_device_info.dart';
import 'package:nui_core/data/nui_ent.dart';

class NUIAuthRenewTokenReq extends NUIEnt<NUIAuthRenewTokenReq>{

  NUIAuthRenewTokenReq({required this.refreshToken, required this.deviceInfo});
  NUIAuthRenewTokenReq.empty();
  late String refreshToken;
  late NUIAuthDeviceInfo deviceInfo;

  @override
  NUIEntMapper<NUIAuthRenewTokenReq> mapper() => NUIAuthRenewTokenReqEnt();

}

class NUIAuthRenewTokenReqEnt extends NUIEntMapper<NUIAuthRenewTokenReq>{
  @override
  String entityName() => "NUIAuthRenewTokenReqEnt";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIAuthRenewTokenReq>(name: "refreshToken", type: NUIEntType.STRING, setter: (data, value) => data.refreshToken = value, getter: (data) => data.refreshToken),
      NUIEntField<NUIAuthRenewTokenReq>(name: "deviceInfo", type: NUIEntType.OBJECT, setter: (data, value) => data.deviceInfo = asObject(NUIAuthDeviceInfoEnt(), value) as NUIAuthDeviceInfo, getter: (data) => data.deviceInfo),
    ];
  }

  @override
  NUIAuthRenewTokenReq newInstance() => NUIAuthRenewTokenReq.empty();

}