import 'package:nui_core/data/nui_ent.dart';

class NUIAuthSignUpReq extends NUIEnt<NUIAuthSignUpReq>{
  NUIAuthSignUpReq.empty();
  NUIAuthSignUpReq({
    required this.username,
    required this.password,
    required this.email,
    this.mobileNo,
    this.name,
    this.displayName,
    this.age,
    this.gender,
    this.recoveryEmail,
    this.provider
  });
  late String username;
  late String password;
  late String email;
  String? mobileNo;
  String? name;
  String? displayName;
  int? age;
  String? gender;
  String? recoveryEmail;
  String? provider;

  @override
  NUIEntMapper<NUIAuthSignUpReq> mapper() => NUIAuthSignUpReqEnt();
}
class NUIAuthSignUpReqEnt extends NUIEntMapper<NUIAuthSignUpReq>{
  @override
  String entityName() => "NUIAuthSignUpReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthSignUpReq>(name: "username", type: NUIEntType.STRING, setter: (data, value) => data.username = value, getter: (data) => data.username),
    NUIEntField<NUIAuthSignUpReq>(name: "password", type: NUIEntType.STRING, setter: (data, value) => data.password = value, getter: (data) => data.password),
    NUIEntField<NUIAuthSignUpReq>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
    NUIEntField<NUIAuthSignUpReq>(name: "mobileNo", type: NUIEntType.STRING, setter: (data, value) => data.mobileNo = value, getter: (data) => data.mobileNo),
    NUIEntField<NUIAuthSignUpReq>(name: "name", type: NUIEntType.STRING, setter: (data, value) => data.name = value, getter: (data) => data.name),
    NUIEntField<NUIAuthSignUpReq>(name: "displayName", type: NUIEntType.STRING, setter: (data, value) => data.displayName = value, getter: (data) => data.displayName),
    NUIEntField<NUIAuthSignUpReq>(name: "age", type: NUIEntType.INTEGER, setter: (data, value) => data.age = value, getter: (data) => data.age),
    NUIEntField<NUIAuthSignUpReq>(name: "gender", type: NUIEntType.STRING, setter: (data, value) => data.gender = value, getter: (data) => data.gender),
    NUIEntField<NUIAuthSignUpReq>(name: "recoveryEmail", type: NUIEntType.STRING, setter: (data, value) => data.recoveryEmail = value, getter: (data) => data.recoveryEmail),
    NUIEntField<NUIAuthSignUpReq>(name: "provider", type: NUIEntType.STRING, setter: (data, value) => data.provider = value, getter: (data) => data.provider),
  ];

  @override
  NUIAuthSignUpReq newInstance() => NUIAuthSignUpReq.empty();
}