
import 'package:nui_core/data/nui_ent.dart';

typedef DataSetter = dynamic Function(dynamic);

class NUIAuthStandardResp extends NUIEnt<NUIAuthStandardResp>{

  NUIAuthStandardResp(this.dataType, this.dataSetter);
  NUIAuthStandardResp.empty();
  late final NUIEntType dataType;
  late final DataSetter dataSetter;

  late bool success;
  String? message;
  NUIAuthStandardError? error;
  late dynamic data;

  @override
  NUIEntMapper<NUIAuthStandardResp> mapper() => NUIAuthStandardRespEnt(dataType, dataSetter);

}
class NUIAuthStandardRespEnt extends NUIEntMapper<NUIAuthStandardResp>{

  NUIAuthStandardRespEnt(this.dataType, this.dataSetter);
  final NUIEntType dataType;
  final DataSetter dataSetter;

  @override
  String entityName() => "NUIAuthStandardRespEnt";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIAuthStandardResp>(name: "success", type: NUIEntType.STRING, setter: (data, value) => data.success = value, getter: (data) => data.success),
      NUIEntField<NUIAuthStandardResp>(name: "message", type: NUIEntType.STRING, setter: (data, value) => data.message = value, getter: (data) => data.message),
      NUIEntField<NUIAuthStandardResp>(name: "error", type: NUIEntType.OBJECT, setter: (data, value) => data.error = asObject<NUIAuthStandardError?>(NUIAuthStandardErrorEnt(), value) as NUIAuthStandardError, getter: (data) => data.error),
      NUIEntField<NUIAuthStandardResp>(name: "data", type: dataType, setter: (data, value) =>  data.data = dataSetter(value), getter: (data) => data.data),
    ];
  }

  @override
  NUIAuthStandardResp newInstance() => NUIAuthStandardResp.empty();

}

class NUIAuthStandardError extends NUIEnt<NUIAuthStandardError>{

  NUIAuthStandardError();
  NUIAuthStandardError.empty();
  String? errorCode;
  String? errorMessage;

  @override
  NUIEntMapper<NUIAuthStandardError> mapper() => NUIAuthStandardErrorEnt();

}
class NUIAuthStandardErrorEnt extends NUIEntMapper<NUIAuthStandardError>{
  @override
  String entityName() => "NUIAuthStandardErrorEnt";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIAuthStandardError>(name: "errorCode", type: NUIEntType.STRING, setter: (data, value) => data.errorCode = value, getter: (data) => data.errorCode),
      NUIEntField<NUIAuthStandardError>(name: "errorMessage", type: NUIEntType.STRING, setter: (data, value) => data.errorMessage = value, getter: (data) => data.errorMessage),
    ];
  }

  @override
  NUIAuthStandardError newInstance() => NUIAuthStandardError.empty();

}