import 'package:nui_core/data/nui_ent.dart';

class NUIAuthLogoutReq extends NUIEnt<NUIAuthLogoutReq>{
  NUIAuthLogoutReq.empty();
  NUIAuthLogoutReq({this.accessToken});
  String? accessToken;

  @override
  NUIEntMapper<NUIAuthLogoutReq> mapper() => NUIAuthLogoutReqEnt();
}
class NUIAuthLogoutReqEnt extends NUIEntMapper<NUIAuthLogoutReq>{
  @override
  String entityName() => "NUIAuthLogoutReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthLogoutReq>(name: "accessToken", type: NUIEntType.STRING, setter: (data, value) => data.accessToken = value, getter: (data) => data.accessToken),
  ];

  @override
  NUIAuthLogoutReq newInstance() => NUIAuthLogoutReq.empty();
}

class NUIAuthSSOSignUpReq extends NUIEnt<NUIAuthSSOSignUpReq>{
  static const String SSO_TYPE_FACEBOOK = "fb";
  static const String SSO_TYPE_GOOGLE = "google";
  static const String SSO_TYPE_APPLE = "apple";

  NUIAuthSSOSignUpReq.empty();
  NUIAuthSSOSignUpReq({required this.provider, required this.providerToken, required this.email});
  late String provider;
  late String providerToken;
  late String email;

  @override
  NUIEntMapper<NUIAuthSSOSignUpReq> mapper() => NUIAuthSSOSignUpReqEnt();
}
class NUIAuthSSOSignUpReqEnt extends NUIEntMapper<NUIAuthSSOSignUpReq>{
  @override
  String entityName() => "NUIAuthSSOSignUpReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthSSOSignUpReq>(name: "provider", type: NUIEntType.STRING, setter: (data, value) => data.provider = value, getter: (data) => data.provider),
    NUIEntField<NUIAuthSSOSignUpReq>(name: "providerToken", type: NUIEntType.STRING, setter: (data, value) => data.providerToken = value, getter: (data) => data.providerToken),
    NUIEntField<NUIAuthSSOSignUpReq>(name: "email", type: NUIEntType.STRING, setter: (data, value) => data.email = value, getter: (data) => data.email),
  ];

  @override
  NUIAuthSSOSignUpReq newInstance() => NUIAuthSSOSignUpReq.empty();
}

class NUIAuthVerifyEmailReq extends NUIEnt<NUIAuthVerifyEmailReq>{
  NUIAuthVerifyEmailReq.empty();
  NUIAuthVerifyEmailReq({this.code, required this.token});
  String? code;
  late String token;

  @override
  NUIEntMapper<NUIAuthVerifyEmailReq> mapper() => NUIAuthVerifyEmailReqEnt();
}
class NUIAuthVerifyEmailReqEnt extends NUIEntMapper<NUIAuthVerifyEmailReq>{
  @override
  String entityName() => "NUIAuthVerifyEmailReq";

  @override
  List<NUIEntField> fields() => [
    NUIEntField<NUIAuthVerifyEmailReq>(name: "code", type: NUIEntType.STRING, setter: (data, value) => data.code = value, getter: (data) => data.code),
    NUIEntField<NUIAuthVerifyEmailReq>(name: "token", type: NUIEntType.STRING, setter: (data, value) => data.token = value, getter: (data) => data.token),
  ];

  @override
  NUIAuthVerifyEmailReq newInstance() => NUIAuthVerifyEmailReq.empty();
}
